{$M 16384,0,16384}
uses crt,dos,nwMisc,nwBindry,printer;
const kennung='gat';

procedure PrintSheet(var out :text; var log,s,pw:string);
var t :text;
    x :string;
begin
  writeln(out,'Name: '+s);
  writeln(out,'Login: '+log);
  writeln(out,'Passwort: '+pw);
  assign(t,'create.txt');
  reset(t);
  while not eof(t) do
    begin readln(t,x); writeln(out,x); end;
  write(out,#12);
  close(t)
end;

procedure WriteUserLine(var infoblatt,out,lxlog,g :text; s:string; var aktnr :word; nrsheets :byte);
var log, pw :string;
    i       :byte;
    objID   :LongInt;
    error   :integer;
    t,u     :string;

const Tag :Array[0..6] of string[10] =('Sonntag','Montag','Dienstag',
                             'Mittwoch','Donnerstag','Freitag','Samstag');
var   Hour, Minute, Second, Sec100,
      Year, Month, Day, DayOfWeek   :Word;

  function zweistell(n :word) :string;
  var s :string[2];
  begin
    Str(n:2,s);
    if s[1]=' ' then s[1]:='0';
    zweistell:=s
  end;

  function klein(s :string) :string;
  var i :byte;
  begin
    for i:=1 to byte(s[0]) do
      if ('A'<=s[i]) and (s[i]<='F') then s[i]:=chr(byte(s[i])+32);
    klein:=s
  end;

begin
  { Suche freie Nummer }
  repeat
    inc(aktnr);
    log:=kennung+klein(HexStr(aktnr,3))
  until not GetBinderyObjectID(log,OT_USER,objID);

  { Zufallspasswort errechnen }
  pw[0]:=#5;
  for i:=1 to 5 do pw[i]:=chr(Random(25)+97);

  { Linux-Eintrag bauen }
  t:=log+':'+s+':'+pw+':';

  { MAKEUSER-Eintrag bauen }
  u:='#create '+log+';'+s+';'+pw+'^';

  { Ausgaben }
  writeln(u);
  writeln(out,u);
  writeln(lxlog,t);

  { Datum und Uhrzeit ermitteln }
  GetDate(Year,Month,Day,DayOfWeek);
  GetTime(Hour,Minute,Second,Sec100);

  { Log-Datei schreiben }
  writeln(g,Tag[DayOfWeek],', ',Day,'.',Month,'.',Year,', ',
            Hour,':',zweistell(Minute),':',zweistell(Second),
            '   ',s);

  { Infoseiten drucken }
  for i:=1 to nrsheets do PrintSheet(infoblatt,log,s,pw)
end;

var t,out,infile,infoblatt,lxlog,g:text;
    s:string;
    n:integer;
    aktnr   :word;
    nrsheets:byte;

begin
  { Initialisierungen }
  randomize;
  aktnr:=0;

  { Ein- und Ausgabedateien oeffnen: }
  { Datei mit Standard-Benutzer-Parametern }
  assign(t,'stduser.usr');
  reset(t);

  { Script fuer MAKEUSER }
  assign(out,'makeuser.usr');
  rewrite(out);

  { Info-Blaetter fuer Schueler }
  assign(infoblatt,'infos.prn');
  rewrite(infoblatt);

  { Uebergabe der Informationen an Linux-Maschine, anhaengend }
  assign(lxlog,'newusers.dat');
  {$I-} append(lxlog); {$I+}
  if ioresult<>0 then rewrite(lxlog);
  if IOResult<>0 then exit;

  { Passwort-Liste }
  Assign(g,'neue.pwd');
  {$I-} Append(g); {$I+}
  if IOResult<>0 then Rewrite(g);
  if IOResult<>0 then exit;

  { Begruessung ausgeben und Zahl der Infoblaetter einlesen }
  writeln('CREATE - neue GAT User anlegen, (c) O. Schmidt, H. Hansen, 1996');
  write('Wieviele Infoseiten moechten Sie pro Schler drucken ? (0=keine)');
  readln(nrsheets);

  { Standard-Parameter aus Vorgabendatei in MAKEUSER-Skript uebertragen }
  while not(eof(t)) do
    begin
      readln(t,s);
      writeln(out,s);
      writeln(s);
    end;
  close(t);

  { Wenn keine Programm-Parameter, dann interaktiv }
  if paramcount = 0 then
    repeat
       { Namen eines Benutzers einlesen }
       write('Geben Sie den Namen des Schlers ein: ');
       readln(s);
       { entsprechende Aktionen vornehmen -> WriteUserLine }
       if s<>'' then WriteUserLine(infoblatt,out,lxlog,g,s,aktnr,nrsheets);
    { Ende bei leerem Namen }
    until s=''
  { Datei mit Namensliste als Parameter }
  else begin
    { Datei oeffnen }
    assign(infile,paramstr(1));
    reset(infile);
    { solange in der Datei noch was drinsteht... }
    while not eof(infile) do
      begin
        { Namen einlesen }
        readln(infile,s);
        { entsprechende Aktionen vornehmen -> WriteUserLine }
        WriteUserLine(infoblatt,out,lxlog,g,s,aktnr,nrsheets);
      end;
    { Eingabedatei schliessen }
    close(infile);
  end;
  { Ausgabedateien schliessen }
  close(g);
  close(lxlog);
  close(out);
  close(infoblatt);

  write('Infoseiten drucken? (j/n) ');
  if upcase(readkey) <> 'J' then halt;
  writeln('J');

  { Info-Seiten drucken }
{  assign(infoblatt,'infos.prn');}
  writeln('Das dauert ein Weilchen...');
  reset(infoblatt);
  n:=0;
  while not eof(infoblatt) do begin
    readln(infoblatt,s);
    if s[1]=#12 then begin
      inc(n);
      write(n,', ')
    end;
    repeat
      {$I-}
      writeln(lst,s);
      {$I+}
    until ioresult=0;
  end;
  writeln;

  { Wirklich alles einrichten? }
  write('MAKEUSER ausfhren? (j/n) ');
  if upcase(readkey) <> 'J' then halt;
  writeln('J');

  { Makeuser aufrufen, also alles einrichten }
  SwapVectors;
  Exec('makeuser.exe','makeuser.usr');
  SwapVectors;

  { Konnte Makeuser ausgefuehrt werden? }
  n:=DOSError;
  if n<>0 then
    begin
      writeln('Ich konnte MAKEUSER nicht ausfhren! (',n,')');
      halt;
    end;

  { Ergebnisse von MAKEUSER ausgeben }
  assign(t,'makeuser.rpt');
  reset(t);
  while not eof(t) do
    begin
      readln(t,s);
      writeln(s);
    end;

  { MAKEUSR-Skript loeschen }
  erase(out)
end.
